[Setup]
DisableWelcomePage=True
DisableFinishedPage=True
AppName=Tastaturbelegung Deutsch (Europisch) mit Sonderzeichen
AppVersion=2.1.1
AppCopyright= 20142019 Yves Goergen
CreateAppDir=False
ShowLanguageDialog=no
DisableProgramGroupPage=yes
Uninstallable=yes
OutputDir=..\publish
OutputBaseFilename=Tastaturbelegung-de-eu
WizardImageBackColor=$ffffff
WizardImageStretch=no
WizardSmallImageFile=Small.bmp
AlwaysRestart=True
UninstallRestartComputer=True
ArchitecturesInstallIn64BitMode=x64
AppPublisher=Yves Goergen
AppPublisherURL=https://unclassified.software/topics/kbd-de-eu
VersionInfoVersion=2.1.1
VersionInfoDescription=Tastaturbelegung Deutsch (Europisch) mit Sonderzeichen
VersionInfoCopyright= 20142019 Yves Goergen
SetupIconFile=kbd-de-eu.ico
UninstallDisplayIcon={sys}\kbd-de-eu.ico

[Languages]
Name: "de"; MessagesFile: "compiler:Languages\German.isl"

[LangOptions]
DialogFontName=Segoe UI
DialogFontSize=9

[Messages]
de.ReadyLabel2b=Dieses Setup-Programm installiert die Tastaturbelegung Deutsch (Europisch) mit Sonderzeichen (Version2.1.1), die die Eingabesprache Deutsch (Standard) um zustzliche Akzentvarianten fr alle europischen Sprachen und gebruchliche Sonderzeichen erweitert.%n%nWeitere Informationen im Web: unclassified.software/de-eu%n%nDie Tastaturbelegung ersetzt Deutsch (Standard) fr alle Benutzer auf diesem Computer. Eine weitere Konfiguration ist nicht erforderlich. Nach der Installation muss der Computer neugestartet werden.%n%nDie Deinstallation erfolgt regulr ber die Systemsteuerung. Dabei wird die ursprngliche Tastaturbelegung von Microsoft wiederhergestellt.%n%nKlicken Sie auf Installieren, um fortzufahren.

[Files]
Source: "amd64\kbd-de-eu.dll"; DestDir: "{sys}"; Flags: ignoreversion uninsrestartdelete; Check: Is64BitInstallMode
Source: "i386\kbd-de-eu.dll"; DestDir: "{sys}"; Flags: ignoreversion uninsrestartdelete; Check: not Is64BitInstallMode
Source: "kbd-de-eu.ico"; DestDir: "{sys}"

[Code]
procedure RegRenameStringValue(const rootKey: Integer; const subKeyName, valueName, newValueName: String);
var
	value: String;
begin
	// Don't overwrite new value; only rename if the value exists
	if not RegQueryStringValue(rootKey, subKeyName, newValueName, value) and RegQueryStringValue(rootKey, subKeyName, valueName, value) then
	begin
		RegWriteStringValue(rootKey, subKeyName, newValueName, value);
		RegDeleteValue(rootKey, subKeyName, valueName);
	end;
end;

procedure CurStepChanged(CurStep: TSetupStep);
begin
	if CurStep = ssPostInstall then
	begin
		// Backup registry value and add new one
		RegRenameStringValue(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Keyboard Layouts\00000407', 'Layout File', 'Layout File_bak');
		RegWriteStringValue(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Keyboard Layouts\00000407', 'Layout File', 'kbd-de-eu.dll');
	end;
end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
begin
	if CurUninstallStep = usUninstall then
	begin
		// Restore original registry value
		RegDeleteValue(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Keyboard Layouts\00000407', 'Layout File_bak');
		RegRenameStringValue(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Keyboard Layouts\00000407', 'Layout File_bak', 'Layout File');
	end;
end;

procedure CancelButtonClick(CurPageID: Integer; var Cancel, Confirm: Boolean);
begin
	Cancel := true;
	Confirm := false;
end;
